import java.io.*;
import java.util.*;

public class clock {
	
	public static char[][] tableFirst = {
		{'.', '.', '.', '.', '.', '.', '.'}, //empty
		{'.', '.', '|', '.', '.', '|', '.'}, //1
		{'-', '.', '|', '-', '|', '.', '-'}  //2
	};
	
	public static char[][] table = {
		{'-', '|', '|', '.', '|', '|', '-'}, //0
		{'.', '.', '|', '.', '.', '|', '.'}, //1
		{'-', '.', '|', '-', '|', '.', '-'}, //2
		{'-', '.', '|', '-', '.', '|', '-'}, //3
		{'.', '|', '|', '-', '.', '|', '.'}, //4
		{'-', '|', '.', '-', '.', '|', '-'}, //5
		{'-', '|', '.', '-', '|', '|', '-'}, //6
		{'-', '.', '|', '.', '.', '|', '.'}, //7
		{'-', '|', '|', '-', '|', '|', '-'}, //8
		{'-', '|', '|', '-', '.', '|', '-'}, //9
		{'.', '.', '.', '.', '.', '.', '.'}  //empty
	};
	
	static Scanner sc = new Scanner(System.in);
	static int s;
	static char[][][] samples;
	static int[][] times;
	
	public static void main(String[] args){
		while(true){
			s = sc.nextInt(); //number of samples
			
			if(s==0) break;
		
			samples = new char[s][][]; //indexy: sample <0-s), cislo <0-3>, znak <0-6>
			times = new int[s][]; //indexy: pred kterym samplem<1-s), [min][max]
			ret = new String[s];
			retnum = new int[s];
		
			for(int i=0;i<s;i++){ //read samples
				if(i!=0) {
					times[i] = readTimes(); //pred kazdym krom prvniho jsou rozsahy mezery
				}
				samples[i] = readSample();
			}
		
			check(0, 0, 0, 24*60);
			
			for(int i=0; i<s; i++){
				System.out.println(ret[i]);
			}
		}
	}
	
	
	static String[] ret;
	static int[] retnum;
	
	
	public static void check(int idx, int time, int min, int max){
		int tmph1, tmph2, tmpm1, tmpm2, tmp;
		for(int h1=0; h1<=2; h1++){
			if(isSame(samples[idx][0], tableFirst[h1]))
				tmph1 = 600*h1;
			else
				continue;
			for(int h2=0; (h1==2 && h2<=5)|| h2<9; h2++){
				if(isSame(samples[idx][1], table[h2]))
					tmph2 = 60*h2;
				else
					continue;
				for(int m1=0; m1<=5; m1++){
					if(isSame(samples[idx][2], table[m1]))
						tmpm1 = 10*m1;
					else
						continue;
					for(int m2=0; m2<=9; m2++){
						if(isSame(samples[idx][3], table[m2]))
							tmpm2 = m2;
						else
							continue;
						
						tmp = tmph1 + tmph2 + tmpm1 + tmpm2;
						
						if((tmp >= time+min) && (tmp <= time+max)){
							retnum[idx]++;
							
							if(retnum[idx] > 1)
								ret[idx] = "ambiguous, " + retnum[idx] + " possibilities";
							else
								ret[idx] = timeToString(tmp);
							
							if(idx != s-1){
								check(idx+1, tmp, times[idx][0], times[idx][1]);
							}
						}
					}
				}
			}
		}
	}
	
	public static String timeToString(int time){
		int hour = (int)time/60;
		int minu = time%60;
		return "" + hour + ":" + minu;
	}
	
	public static boolean isSame(char[]a, char[]b){
		boolean ret = false;
		for(int i=0; i<7; i++){
			ret = ((a[i]==b[i]) || b[i]=='?');
		}
		return ret;
	}
	
	
	public static char[][] readSample(){
		char[][] nums = new char[4][7]; //4 cislice po sedmi znacich
		for(int j=0; j<4; j++){
			nums[j][0] = sc.next().charAt(0);
		}
		for(int j=0; j<4; j++){
			nums[j][1] = sc.next().charAt(0);
			nums[j][2] = sc.next().charAt(0);
		}
		for(int j=0; j<4; j++){
			nums[j][3] = sc.next().charAt(0);
		}
		for(int j=0; j<4; j++){
			nums[j][4] = sc.next().charAt(0);
			nums[j][5] = sc.next().charAt(0);
		}
		for(int j=0; j<4; j++){
			nums[j][6] = sc.next().charAt(0);
		}
		
		for(int i=0; i<4; i++){
			for(int j=0; j<7; j++){
				System.out.print(nums[i][j]);
			}
			System.out.println();
		}
		
		return nums;
	}
	
	public static int[] readTimes(){
		int times[] = new int[2];
		times[0] = sc.nextInt();
		times[1] = sc.nextInt();
		return times;
	}
	
}